<?php
/*
Plugin Name: 2nd Page Sniper
Plugin URI: http://www.spontent.com/blog/2nd-page-sniper-wordpress-plugin
Description: 2nd Page Sniper Plugin (second-page-poaching) 
The average #11 ranking site in Google will get a relative 0.66% click through ratio (CTR), yet the average #10 ranking will get a 2.97% CTR.  

Put simply, this means a 450% increase in traffic simply by moving from position #11 to #10.  The same applies for lower positions such as #20 (a 0.30% CTR), a 990% increase by moving to position #10.

For long tail keyword phrases and keywords where you're on the edge of moving to page #1, this plugin will help by sculpting pagerank and adding internal site wide links to phrases where you are on the brink of busting into a top 10 position.

More details in our Beyond Link Building Report: http://myautoblogger.org/Beyond_Link_Building.pdf 

2nd Page Sniper will automatically prioritize links displayed by first displaying keywords
most likely to be boosted with the greatest traffic result (ie Page 2, then page 3, etc, 
then page 1 results as a last resort)

Version: 1.0
Author: Spontent
Author URI: http://www.spontent.com
License: customer-license
*/



// Avoid direct access to the pluggin file outside wordpress.
if ( isqacl_file ( basename(__FILE__), $_SERVER['PHP_SELF'] ) )
{ 
	die('Direct access not allowed!');
}

global $isqlinks_db_version;


$isqlinks_db_version = "1.0";

//add_action('init','isqlinks_analyze');
add_filter('wp_head', 'isqlinks_analyze');
add_action('widgets_init', create_function('', 'return register_widget("isqlinksWidget");'));
register_activation_hook(__FILE__,'isqlinks_install');

/**
 * Install process for isq-links
 *
 */ 
function isqlinks_install()
{
global $wpdb;
global $isqlinks_db_version;

$table_name = $wpdb->prefix . "isqlinks";

	if ( file_exists(ABSPATH . 'wp-admin/includes/upgrade.php') ) 
	{
		require_once(ABSPATH . '/wp-admin/includes/upgrade.php');
	}else{
		echo 'This plugin requires WordPress >= 2.8';
    	exit();
	}

	$installed_ver = get_option( 'isqlinks_db_version' );
	//@todo place this on deactivate event of plugins.
	if ( $installed_ver == TRUE) delete_option( 'isqlinks_db_version' );

	if ( $installed_ver == FALSE ) 
	{
		/*
		 * Install for first time
		 */

		if( $wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name ) 
		{
			$sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " (".
				"id BIGINT(11) NOT NULL AUTO_INCREMENT,".				
				"ts TIMESTAMP DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,".
				"from_sitename VARCHAR(32) NOT NULL, ". /* google, yahoo, ... */
				"from_pagenumber TINYINT NOT NULL, ". /* page 2, page 3, ... */
				"target_type VARCHAR(8) NOT NULL, ". /* post, page, category */
				"target_id BIGINT(11) NOT NULL, ".
				"hits BIGINT(11) NOT NULL DEFAULT 0, ". /* number of hits for a keyword */
				"keyword VARCHAR(254) NOT NULL, ".
				"referrer TEXT NOT NULL, ".
				"UNIQUE KEY id (id));";
		dbDelta( $sql );
	
		add_option( "isqlinks_db_version", $isqlinks_db_version );
		}
	}
	elseif ( $installed_ver != $isqlinks_db_version ) 
	{
		// update to a new version
	}



unset( $wpdb );
unset( $isqlinks_db_version );
unset( $installed_ver );
}


/**
 * Analyze Incoming Traffic.
 * @return boolean TRUE | FALSE (FALSE is not monitoring).
 *
 */
function isqlinks_analyze()
{
global $wpdb,$wp_query;

	if ( get_option('isqlinks_logpost') == FALSE && is_single() ) return FALSE;
	if ( get_option('isqlinks_logfeed') == FALSE && is_feed() ) return FALSE;
	if ( get_option('isqlinks_logcategory') == FALSE && is_category() ) return FALSE; 
	if ( get_option('isqlinks_loghomepage') == FALSE && is_front_page() ) return FALSE;


	if( !isset( $_SERVER['HTTP_REFERER'] ) ) return FALSE;
	
	$referer= ( $_SERVER['HTTP_REFERER']) ;
    if ($referer=='') return FALSE;
	$data=isqlinks_analyze_parser($referer);
	$data[ 'referrer' ] = $referer;

    if ( !isset( $wp_query->post->ID ) ) 
		( isset($_GET['p']) ) ? ( $post_id = (int) $_GET['p'] ) : ( $post_id = get_the_ID() ); 
	else
		$post_id = $wp_query->post->ID;	



	if ( $data != FALSE ) 
	{
		if ( is_single( "$post_id" ) != FALSE) 
		{
			$data[ 'target_type' ] = 'POST';
			$data[ 'target_id']    = $post_id;
		}
		elseif ( is_front_page() ) 
		{
			$data[ 'target_type' ] = 'HOMEPAGE';
			$data[ 'target_id']    = (int) $post_id;
		}
		elseif ( is_category() )
		{
		    $data[ 'target_type' ] = 'CATEGORY';
			$data[ 'target_id' ] = (int) $post_id;
		}
		elseif ( is_feed() )
		{
		    $data[ 'target_type' ] = 'FEED';
			$data[ 'target_id' ] = (int) $post_id;
		}
		else { /* */ }
	}
	else
	{
		return FALSE;
	}

	$google_nprefix = get_option( "isqlinks_google_notprefix" );

	if ( $google_nprefix == 'on' )
	{

			/* This is not only for google, other search engines are using the
			 * same tags in several cases. So this is for google, bing, yahoo.
			 * note: We don't print it in widget results, only logs in db 
			 * for traffic research pourposes.
			 */
		$gprefix = array ('link:', 'related:', 'site:', 'allinurl:', 'inurl:',
			'allintitle:', 'intitle:', 'cache:', 'info:', 'spell:', 'stocks:',
			'filetype:', 'daterange:', 'maps:', 'phone:', 'allinlinks:',
			'allintext', 'allinanchor');

		foreach ($gprefix as $p) 
		{
			if (preg_match("/$p/", urldecode( trim( $data[ 'keyword' ] ) ) ) ) return FALSE;
		}
	}

	$table_name = $wpdb->prefix . 'isqlinks';
	$from_sitename   = $data [ 'from_sitename' ];
	$from_pagenumber = (int) $data[ 'from_pagenumber' ] ;
	$keyword         = $data[ 'keyword' ];
	$referrer        = $data[ 'referrer' ];
	$target_type     = $data[ 'target_type' ];
	$target_id       = $data[ 'target_id' ];

	$google_search = get_option('isqlinks_google', FALSE);
	$bing_search   = get_option('isqlinks_bing', FALSE);
	$yahoo_search  = get_option('isqlinks_yahoo', FALSE);


	if     ( preg_match( "/google/i", $from_sitename ) && $google_search == FALSE )
		return FALSE;
	elseif ( preg_match( "/bing/i", $from_sitename ) && $bing_search == FALSE )
		return FALSE;
	elseif ( preg_match( "/yahoo/i", $from_sitename) && $yahoo_search == FALSE )
		return FALSE;
	elseif ( !preg_match ("/(google|bing|yahoo)/", $from_sitename) ) return FALSE;
	else { /* */ }


		$sql = "SELECT hits FROM $table_name WHERE keyword='". urldecode( $keyword ) ."'";
		$hits = $wpdb->get_var( $wpdb->prepare( $sql ) );


	if ( $hits != NULL ) 
	{
		$hits = intval( "$hits" ) + 1;
		$wpdb->update( $table_name, 
		array( 'from_sitename' => $from_sitename, 'from_pagenumber' => $from_pagenumber,  'referrer' => $referrer,
				'target_type' => $target_type, 	'target_id' => $target_id, 'hits' => $hits ), 
		array( 'keyword' => urldecode( $keyword ) ) 
		);
	}
	else
	{
		$wpdb->insert( $table_name,
		array( 'from_sitename' =>  $from_sitename, 'from_pagenumber' => $from_pagenumber,  'referrer' => $referrer,
			'target_type' => $target_type, 'target_id' => $target_id, 'keyword' => urldecode( $keyword) , 'hits' => 1 ) 
		);
	}

unset( $wpdb );
unset( $wp_query );
unset( $data );
unset( $google_notprefix );
}


/**
 * Parse referer data and return array with data from referer.
 * @return mixted array | FALSE (FALSE data is not valid).
 */
function isqlinks_analyze_parser($referer)
{
 

   if (is_numeric($referer)) return FALSE;

	//	from_sitename, from_pagenumber, keyword 
	//	google bing search q= 
	//	yahoo p=
	if ( preg_match( "/[&\?](q|p)=([^&]+)/i", $referer, $querystring) )
	{
		if ( preg_match( "@^(?:https?://)?([^/]+)@i", $referer, $from_site ) )
		{
				$from_sitename  = trim( strtolower( $from_site[1] ) );
				$keyword = str_replace( '+',' ', $querystring[2] );

			if ( preg_match( "/[&\?](start|b|first|stq)=([0-9]*)/i", $referer, $querystring))
			{
				$page_offset = trim( $querystring[2] );
				$from_pagenumber = (int) floor( ( intval( "$page_offset" ) / 10 ) + 1 );
			}
			elseif ( get_option( 'isqlinks_pageone' ) != FALSE ) 
			{
				$from_pagenumber = 1;
			}

		}
	}

	if ($from_sitename != '' && $keyword != '' && $from_pagenumber > 0 )
	{
	    $data = array ( 'from_sitename'   => $from_sitename,
						'from_pagenumber' => $from_pagenumber,
						'keyword'         => $keyword);
		return $data;
	}


return FALSE;
}



/**
 * Check Access to files from outside wordpress.
 * @return TRUE|FALSE
 */


function isqacl_file($file, $frompath)
{
	return preg_match( '%'.$file.'%', $frompath) ;
}


/**
 * FooWidget Class
 */
class isqlinksWidget extends WP_Widget {
    /** constructor */
    function isqlinksWidget() {
        parent::WP_Widget(FALSE, $name = '2nd Page Sniper');	
    }

    /** @see WP_Widget::widget */
	function widget($args, $instance) {		
		global $wpdb;
		$table_name = $wpdb->prefix . 'isqlinks';
        extract( $args );
        $title = apply_filters('widget_title', $instance['title']);

			echo $before_widget; 
				if ( $title )
					echo $before_title . $title . $after_title; 
				
			/* ----------------------------------------------------------
			 * We print links in this section.
			 * TODO: Detect Keywords not changing position after weeks and drop them from the list
			 * We have to setup options in widget options area.
			 * Widget name: isqlinksWidget drag it to your sidebar widget.
			 * ---------------------------------------------------------*/
			$maxlinks = get_option('maxlinks', FALSE);
			if ($maxlinks == FALSE) $maxlinks = 20;

			$pagenum = 2;
			$sql = "SELECT keyword, target_type, target_id ".
				"FROM $table_name WHERE from_pagenumber=$pagenum ORDER BY hits DESC LIMIT $maxlinks";
			$rs = $wpdb->get_results( $wpdb->prepare( $sql ), OBJECT );

		    $numrows = count($rs);
			// if exists less than maxlinks then list all pages > 1 ordered by asc
			if ( $numrows < $maxlinks )
			{	
				$sql = "SELECT keyword, target_type, target_id FROM $table_name ".
					"WHERE from_pagenumber > 1 ORDER BY from_pagenumber ASC, hits DESC LIMIT $maxlinks";
				$rs = array_merge($rs, $wpdb->get_results( $wpdb->prepare( $sql ), OBJECT ));
			}

		    $numrows = count($rs);			
			// as a last resort use Page 1 results
			if ( $numrows < $maxlinks )
			{
				( get_option('isqlinks_pageone') == FALSE ) ? $pagenum = 2 : $pagenum = 1;
				$sql = "SELECT keyword, target_type, target_id FROM $table_name ".
					"WHERE from_pagenumber = 1 ORDER BY from_pagenumber ASC, hits DESC LIMIT $maxlinks";
				$rs = array_merge($rs, $wpdb->get_results( $wpdb->prepare( $sql ), OBJECT ));
			}
			
			foreach ($rs as $link) 
			{
					//print_r( (array) $link );
				$link = (array) $link;
				$keyword = $link['keyword'];
				$tid = $link['target_id'];
				( intval( $tid ) > 0 ) ? $url = get_permalink( intval( $tid ) ) : $url = '/';
				$anchorlink = "<div class=\"anchorlink\"><a href=\"$url\">$keyword</a></div>";
				echo $anchorlink;
			}
			echo $after_widget; 
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
			
		$instance = $old_instance;
		$instance['title'] = strip_tags( $new_instance['title'] );
	    if ( !is_numeric( $new_instance['maxlinks'] ) ) $new_instance['maxlinks'] = 1;
		$instance['maxlinks'] = (int)$new_instance['maxlinks'];
		$instance['selist1'] = $new_instance['selist1'];
		$instance['selist2'] = $new_instance['selist2'];
		$instance['selist3'] = $new_instance['selist3'];
		$instance['pagelogs1'] = $new_instance['pagelogs1'];
		$instance['pagelogs2'] = $new_instance['pagelogs2'];
		$instance['pagelogs3'] = $new_instance['pagelogs3'];
		$instance['pagelogs4'] = $new_instance['pagelogs4'];
		$instance['startpageoffset'] = $new_instance['startpageoffset'];

		$instance['prefix'] = $new_instance['prefix'];
		update_option( 'isqlinks_google_notprefix', $instance['prefix'] ); 

		( $instance['selist1'] == 'on' ) ?
			update_option( 'isqlinks_google', $instance['selist1'] ) :
			update_option( 'isqlinks_google', FALSE );

		( $instance['selist2'] == 'on' ) ?
			update_option( 'isqlinks_bing',   $instance['selist2'] ) :
			update_option( 'isqlinks_bing',   FALSE );

		( $instance['selist3'] == 'on' ) ?
			update_option( 'isqlinks_yahoo',  $instance['selist3'] ) :
			update_option( 'isqlinks_yahoo',  FALSE );

		( $instance['startpageoffset'] == 'on' ) ?
			update_option( 'isqlinks_pageone', $instance['startpageoffset'] ) :
			update_option( 'isqlinks_pageone', FALSE );

		( $instance['pagelogs1'] == 'on' ) ?
			update_option( 'isqlinks_loghomepage', $instance['pagelogs1'] ) :
			update_option( 'isqlinks_loghomepage', FALSE );

		( $instance['pagelogs2'] == 'on' ) ?
			update_option( 'isqlinks_logpost', $instance['pagelogs2'] ) :
			update_option( 'isqlinks_logpost', FALSE );

		( $instance['pagelogs3'] == 'on' ) ?
			update_option( 'isqlinks_logcategory', $instance['pagelogs3'] ) :
			update_option( 'isqlinks_logcategory', FALSE );

		( $instance['pagelogs4'] == 'on' ) ?
			update_option( 'isqlinks_logfeed', $instance['pagelogs4'] ) :
			update_option( 'isqlinks_logfeed', FALSE );


		update_option( 'maxlinks', $instance['maxlinks'] );

		return $instance;

    }

    /** @see WP_Widget::form */
    function form($instance) {				
		$title = esc_attr( $instance['title'] );
		$maxlinks = esc_attr( (int) $instance['maxlinks'] );
		if ($maxlinks==NULL) $maxlinks = 20; //defaults
		elseif ($maxlinks <= 0) $maxlinks = 1;
		else {/* */ }
		$htmlchecked = "checked=\"true\"";
		($instance['selist1'] == 'on') ? $selist1check = $htmlchecked : $selist1check = '';
		($instance['selist2'] == 'on') ? $selist2check = $htmlchecked : $selist2check = '';
		($instance['selist3'] == 'on') ? $selist3check = $htmlchecked : $selist3check = '';
		// google is the default search engine.
		if ($selist1check == '' && $selist2check == '' && $selist3check == '' ) $selist1check = $htmlchecked;
		($instance['prefix'] == 'on') ? $prefix = $htmlchecked : $prefix = '';
		($instance['startpageoffset'] == 'on') ? $startpagecheck = $htmlchecked : $startpagecheck = '';
		($instance['pagelogs1'] == 'on') ? $pagelogs1check = $htmlchecked : $pagelogs1check = '';
		($instance['pagelogs2'] == 'on') ? $pagelogs2check = $htmlchecked : $pagelogs2check = '';
		($instance['pagelogs3'] == 'on') ? $pagelogs3check = $htmlchecked : $pagelogs3check = '';
		($instance['pagelogs4'] == 'on') ? $pagelogs4check = $htmlchecked : $pagelogs4check = '';
		// we log post by default.
		if ( $pagelogs1check == '' && $pagelogs2check == '' && $pagelogs3check == '' && $pagelogs4check == '' )
			$pagelogs2check = $htmlchecked;
		
?>


		<p><label for="<?php echo $this->get_field_id('title');?>">
	   <?php _e('Title:'); ?> 
           <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" 
	      name="<?php echo $this->get_field_name('title'); ?>" 
			  type="text" value="<?php echo $title; ?>" /></label></p>

		<p><label for="<?php $this->get_field_id('maxlinks');?>"><?php _e('Maximun links:');?>
			<input class="widefat" id="<?php $this->get_field_id('maxlinks');?>" 
			name="<?php echo $this->get_field_name('maxlinks'); ?>" 
				type="text" value="<?php echo $maxlinks; ?>" /></label></p>

		<h3><?php _e('Search engines');?></h3> 
		
		<p><label for="<?php $this->get_field_id('selist');?>"><?php _e('Check it:');?><br />
		<blockquote>


		<input class="checkbox" type="checkbox" <?php echo $selist1check; ?>
		id="<?php echo $this->get_field_id( 'selist1' ); ?>" 
					name="<?php echo $this->get_field_name( 'selist1' ); ?>" />&nbsp;<?php _e('Google');?> &nbsp;

		<input class="checkbox" type="checkbox" <?php echo $selist2check; ?>
				 id="<?php echo $this->get_field_id( 'selist2' ); ?>" 
					name="<?php echo $this->get_field_name( 'selist2' ); ?>" />&nbsp;<?php _e('Bing'); ?> &nbsp;


		<input class="checkbox" type="checkbox" <?php echo $selist3check; ?>
				 id="<?php echo $this->get_field_id( 'selist3' ); ?>" 
					name="<?php echo $this->get_field_name( 'selist3' ); ?>" />&nbsp;<?php _e('Yahoo'); ?> &nbsp;
			<hr />
		</blockquote>
			</label>
		</p>

		<h3><?php _e('Log options'); ?></h3>
		<p><label for="<?php $this->get_field_id('logoptions');?>"><?php _e('Check it:');?></label></p>

		<blockquote>


		<p><label for="<?php echo $this->get_field_id('prefix');?>">
	   <?php _e('Disable prefixes (site:, cache:,etc) :'); ?><br />
           		<input class="checkbox" type="checkbox" <?php echo $prefix; ?>
				 id="<?php echo $this->get_field_id( 'prefix' ); ?>" 
					name="<?php echo $this->get_field_name( 'prefix' ); ?>" />&nbsp;<?php _e('Check to disable'); ?>
		<br />
		<small>This option is experimental.</small>
		</label></p>
	

		<p><label for="<?php echo $this->get_field_id('startpageoffset');?>">
		<?php _e('Log from page 1? ')  ?>
			<input class="checkbox" type="checkbox" <?php echo $startpagecheck; ?>
				id="<?php echo $this->get_field_id( 'startpageoffset' ); ?>" 
					name="<?php echo $this->get_field_name( 'startpageoffset' ); ?>" />
		</label>
		</p>

		<p>
		<label for="<?php echo $this->get_field_id('pagelogs');?>"></label>
		<input class="checkbox" type="checkbox" <?php echo $pagelogs1check; ?>
			 id="<?php echo $this->get_field_id( 'pagelogs1' ); ?>" 
			name="<?php echo $this->get_field_name( 'pagelogs1' ); ?>" />&nbsp;<?php _e('Log Home Page'); ?> &nbsp;<br />


		<input class="checkbox" type="checkbox" <?php echo $pagelogs2check; ?>
			 id="<?php echo $this->get_field_id( 'pagelogs2' ); ?>" 
			name="<?php echo $this->get_field_name( 'pagelogs2' ); ?>" />&nbsp;<?php _e('Log Posts'); ?> &nbsp;<br />

		<input class="checkbox" type="checkbox" <?php echo $pagelogs3check; ?>
			 id="<?php echo $this->get_field_id( 'pagelogs3' ); ?>" 
				name="<?php echo $this->get_field_name( 'pagelogs3' ); ?>" />&nbsp;<?php _e('Log Categories'); ?> &nbsp;<br />

		<input class="checkbox" type="checkbox" <?php echo $pagelogs4check; ?>
			 id="<?php echo $this->get_field_id( 'pagelogs4' ); ?>" 
				name="<?php echo $this->get_field_name( 'pagelogs4' ); ?>" />&nbsp;<?php _e('Log Feeds'); ?> &nbsp;<br />
	
		</p>
		</blockquote>
    <?php 
    }
	
} // class FooWidget

?>
